package
{
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.ui.Mouse;
	
	import org.flixel.*;
	import org.flixel.FlxSprite;
	import org.flixel.FlxState;
	import org.flixel.FlxEmitter;
	import org.flixel.FlxU;
	
	public class GameState extends FlxState
	{
		[Embed(source = "data/tile.png")] public static var TilePics:Class;
		[Embed(source = "data/tile2.png")] public static var TilePics2:Class;
		[Embed(source = "data/note.png")] public static var NoteBmp:Class;
		[Embed(source = "data/flourish.png")] public static var FlourishBmp:Class;
		//[Embed(source = "data/fox.png")] public static var FoxBmp:Class;
		//[Embed(source = "data/spikes.png")] public static var SpikeBmp:Class;
		//[Embed(source = "data/hud.png")] public static var HUDBmp:Class;
		[Embed(source = "data/background.png")] public static var BackgroundBmp:Class;
		[Embed(source = "data/checkpoint.png")] public static var CheckpointBmp:Class;
		[Embed(source = "data/map.png")] public static var MapBitmap:Class;
//		[Embed(source = "data/bg.png")] private var BgImg:Class;
//		[Embed(source = "data/woman.png")] private var ImgWoman:Class;
		//[Embed(source = "data/awefvawefvwef.mp3")] public static var SndMusic:Class;
		
		
		[Embed(source = "data/get.mp3")] public static var SndGet:Class;
		[Embed(source = "data/music.mp3")] public static var SndMusic:Class;
		[Embed(source = "data/whale1.mp3")] public static var SndWhale1:Class;
		[Embed(source = "data/whale2.mp3")] public static var SndWhale2:Class;
		[Embed(source = "data/whale3.mp3")] public static var SndWhale3:Class;
		[Embed(source = "data/whale4.mp3")] public static var SndWhale4:Class;
		[Embed(source = "data/whale5.mp3")] public static var SndWhale5:Class;
		[Embed(source = "data/whale6.mp3")] public static var SndWhale6:Class;
		[Embed(source = "data/whale7.mp3")] public static var SndWhale7:Class;
		[Embed(source = "data/whale8.mp3")] public static var SndWhale8:Class;
		[Embed(source = "data/whale9.mp3")] public static var SndWhale9:Class;
		[Embed(source = "data/whale10.mp3")] public static var SndWhale10:Class;
		
		public static var sndWhale1:FlxSound;
		public static var sndWhale2:FlxSound;
		public static var sndWhale3:FlxSound;
		public static var sndWhale4:FlxSound;
		public static var sndWhale5:FlxSound;
		public static var sndWhale6:FlxSound;
		public static var sndWhale7:FlxSound;
		public static var sndWhale8:FlxSound;
		public static var sndWhale9:FlxSound;
		
//		[Embed(source = "data/sound.mp3")] public static var SndSound:Class;
//		[Embed(source = "data/gameover.mp3")] public static var SndGameover:Class;

		public var player:Player;
		public var respawnPoints:FlxGroup;
		public var tilemap:FlxTilemap;
		public var tilemap2:FlxTilemap;
		
		public var hudtext:FlxText;
		public var hudtexttimer:Number;
		
		public var flourish:FlxEmitter;
		
		public var collectable:Vector.<FlxSprite>;
		static public var collected:Vector.<Boolean>;
		
		public function makeMap(bSpawn:Boolean):FlxTilemap
		{
			var levelStr:String = new String;
			var tempBitmap:Bitmap = new MapBitmap();
			for (var j:int=0;j<tempBitmap.bitmapData.height;j++)
			{
				if (j>0)
				{
					levelStr+="\n";
				}
				
				for (var i:int=0;i<tempBitmap.bitmapData.width;i++)
				{
					if (i>0)
					{
						levelStr+=",";
					}
					var s:String;
					switch (tempBitmap.bitmapData.getPixel(i,j))
					{
						case 0xffffff:
						{
							s="0";		
							break;
						}
						case 0x150000:
						{
							if (Math.random()>=0.5)
							{
								s="2";
							}
							else
							{
								s="3";
							}
							break;
						}
						case 0x5b3b29:
						{
							if (Math.random()>=0.5)
							{
								s="4";
							}
							else
							{
								s="5";
							}
							break;
						}
						case 0x8b7a82:
						{
							if (Math.random()>=0.5)
							{
								s="6";
							}
							else
							{
								s="7";
							}
							break;
						}
						case 0x947e69:
						{
							if (Math.random()>=0.5)
							{
								s="8";
							}
							else
							{
								s="9";
							}
							break;
						}
						case 0xf59625:
						{
							if (Math.random()>=0.5)
							{
								s="10";
							}
							else
							{
								s="11";
							}
							break;
						}
						case 0x9f3d17:
						{
							if (Math.random()>=0.5)
							{
								s="12";
							}
							else
							{
								s="13";
							}
							break;
						}
						case 0x867378:
						{
							if (Math.random()>=0.5)
							{
								s="14";
							}
							else
							{
								s="15";
							}
							break;
						}
						case 0x839952:
						{
							if (Math.random()>=0.5)
							{
								s="16";
							}
							else
							{
								s="17";
							}
							break;
						}
						case 0xf8b93c:
						{
							if (Math.random()>=0.5)
							{
								s="18";
							}
							else
							{
								s="19";
							}
							break;
						}
						
						case 0xff0000:
						{
							if (bSpawn)
							{
								player = new Player(i*6,j*6);
								layer2.add(player);
								layer2.add(player.group);
								FlxG.follow(player,8);
								FlxG.followBounds(0,0,160*6,160*6)
							}
							
							//put active checkpoint at starting position
							if (bSpawn)
							{
								var respawnPoint:FlxSprite = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],6);
								respawnPoint.addAnimation("active",[2,3],6);
								respawnPoint.play("active");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							s="0";
							break;
						}
							
						case 0xff00ff:
						{
							
							s="0";
							break;
						}
							
						case 0x0000ff:
						{
							
							if (bSpawn)
							{
								respawnPoint = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],4);
								respawnPoint.addAnimation("active",[2,3],4);
								respawnPoint.play("inactive");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							this.collectable[8].x=i*6;
							this.collectable[8].y=j*6;
							break;
						}
						case 0x0000f6:
						{
							
							if (bSpawn)
							{
								respawnPoint = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],4);
								respawnPoint.addAnimation("active",[2,3],4);
								respawnPoint.play("inactive");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							this.collectable[7].x=i*6;
							this.collectable[7].y=j*6;
							break;
						}
						case 0x0000ef:
						{
							
							if (bSpawn)
							{
								respawnPoint = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],4);
								respawnPoint.addAnimation("active",[2,3],4);
								respawnPoint.play("inactive");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							this.collectable[6].x=i*6;
							this.collectable[6].y=j*6;
							break;
						}
						case 0x0000e6:
						{
							
							if (bSpawn)
							{
								respawnPoint = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],4);
								respawnPoint.addAnimation("active",[2,3],4);
								respawnPoint.play("inactive");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							this.collectable[5].x=i*6;
							this.collectable[5].y=j*6;
							break;
						}
						case 0x0000df:
						{
							
							if (bSpawn)
							{
								respawnPoint = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],4);
								respawnPoint.addAnimation("active",[2,3],4);
								respawnPoint.play("inactive");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							this.collectable[4].x=i*6;
							this.collectable[4].y=j*6;
							break;
						}
						case 0x0000d6:
						{
							
							if (bSpawn)
							{
								respawnPoint = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],4);
								respawnPoint.addAnimation("active",[2,3],4);
								respawnPoint.play("inactive");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							this.collectable[3].x=i*6;
							this.collectable[3].y=j*6;
							break;
						}
						case 0x0000cf:
						{
							
							if (bSpawn)
							{
								respawnPoint = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],4);
								respawnPoint.addAnimation("active",[2,3],4);
								respawnPoint.play("inactive");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							this.collectable[2].x=i*6;
							this.collectable[2].y=j*6;
							break;
						}
						case 0x0000c6:
						{
							
							if (bSpawn)
							{
								respawnPoint = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],4);
								respawnPoint.addAnimation("active",[2,3],4);
								respawnPoint.play("inactive");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							this.collectable[1].x=i*6;
							this.collectable[1].y=j*6;
							break;
						}
						case 0x0000bf:
						{
							
							if (bSpawn)
							{
								respawnPoint = new FlxSprite(i*6,j*6);
								respawnPoint.loadGraphic(GameState.CheckpointBmp,true,false,6,6);
								respawnPoint.addAnimation("inactive",[0,1],4);
								respawnPoint.addAnimation("active",[2,3],4);
								respawnPoint.play("inactive");
								respawnPoint.solid=false;
								respawnPoints.add(respawnPoint);								
							}
							
							this.collectable[0].x=i*6;
							this.collectable[0].y=j*6;
							break;
						}
						default:
						{
							trace(" color not found " + tempBitmap.bitmapData.getPixel(i,j).toString(16));
							s="0";
						}
					}	
					levelStr+=s;				
				}
			}
			
			var rettilemap:FlxTilemap = new FlxTilemap();
			rettilemap.loadMap(levelStr,TilePics,6,6);
			rettilemap.collideIndex=2;
			return rettilemap;
		}
		
		public var bg:FlxSprite;

		public var layer1:FlxGroup;
		public var layer2:FlxGroup;
		public var layer2b:FlxGroup;
		public var layer3:FlxGroup;
		
		override public function create():void
		{
			FlxG.playMusic(GameState.SndMusic,1.0);
			
			sndWhale1 = new FlxSound();
			sndWhale1.loadEmbedded(SndWhale1,true);
			
			sndWhale2 = new FlxSound();
			sndWhale2.loadEmbedded(SndWhale2,true);
			
			sndWhale3 = new FlxSound();
			sndWhale3.loadEmbedded(SndWhale3,true);
			
			sndWhale4 = new FlxSound();
			sndWhale4.loadEmbedded(SndWhale4,true);
			
			sndWhale5 = new FlxSound();
			sndWhale5.loadEmbedded(SndWhale5,true);
			
			sndWhale6 = new FlxSound();
			sndWhale6.loadEmbedded(SndWhale6,true);
			
			sndWhale7 = new FlxSound();
			sndWhale7.loadEmbedded(SndWhale7,true);
			
			sndWhale8 = new FlxSound();
			sndWhale8.loadEmbedded(SndWhale8,true);
			
			sndWhale9 = new FlxSound();
			sndWhale9.loadEmbedded(SndWhale9,true);
			
			gameover=false;
			bgColor = 0xFF3333CC;
			this._time=0;		
			layer1 = new FlxGroup;
			layer2 = new FlxGroup;
			layer2b = new FlxGroup;
			layer3 = new FlxGroup;
			
			this.add(layer1);
			this.add(layer2);			
			this.add(layer2b);
			this.add(layer3);
			
			//Jet effect that shoots out from behind the bot
			flourish = new FlxEmitter();
			flourish.setRotation();
			flourish.acceleration = new FlxPoint(0,0);			
			flourish.createSprites(FlourishBmp,15,0,true);
			layer2.add(flourish);
			
			hudtext = new FlxText(0,10,FlxG.width,"press number keys to sing");
			hudtext.alignment="center";
			hudtext.scrollFactor = new FlxPoint(0,0);
			hudtext.visible=false;
			hudtext.color=0xff888888;
			this.hudtexttimer=10;
			layer3.add(hudtext);
			//var hud:FlxSprite = new FlxSprite(1,1,GameState.HUDBmp);
			//hud.scrollFactor = new FlxPoint(0,0);
			//layer3.add(hud);
			
			collectable = new Vector.<FlxSprite>;
			collected = new Vector.<Boolean>;
			
			for (var i:int=0;i<9;i++)
			{
				var spr:FlxSprite = new FlxSprite(0,0);
				spr.loadGraphic(NoteBmp,true,false,6,6);
				spr.addAnimation("normal",[0,1],3);
				spr.addAnimation("inactive",[1],0);
				spr.play("normal");
				collectable.push(spr);
				this.layer2b.add(spr);
				collected.push(false);
			}
						
			bg = new FlxSprite(0,0);
			bg.loadGraphic(GameState.BackgroundBmp,false,false);
			//bg.addAnimation("glimmer",[0,1],0.5);
			//bg.play("glimmer");
			//bg.scrollFactor= new FlxPoint(0,1);
			bg.moves=false;
			bg.solid=false;			
			layer1.add(bg);			
			
			respawnPoints = new FlxGroup();
			layer2.add(respawnPoints);
			
			tilemap = this.makeMap(true);
			layer1.add(tilemap);
			
			/*tilemap2 = this.makeMap(false);
			layer1.add(tilemap2);
			tilemap2.visible=false;		
			*/

			//player = new Player();
		}
		
		
		public var _time:Number;
		public var gameover:Boolean;
		
		override public function update():void
		{
			
			if (gameover)
			{
				super.update();
				return;
			}
			
			GameState.sndWhale1.update();
			GameState.sndWhale2.update();
			GameState.sndWhale3.update();
			GameState.sndWhale4.update();
			GameState.sndWhale5.update();
			GameState.sndWhale6.update();
			GameState.sndWhale7.update();
			GameState.sndWhale8.update();
			GameState.sndWhale9.update();
			
			if (hudtexttimer>0 && hudtexttimer<5)
			{
				hudtexttimer-=FlxG.elapsed;
				if (hudtexttimer<=0)
				{
					this.hudtext.visible=false;
				}
			}
			
			for (i=0;i<this.collectable.length;i++)
			{
				if (!collected[i])
				{
					var spr:FlxSprite = collectable[i];
					dx = player.x-spr.x;
					dy = player.y-spr.y;				
					if (dx*dx+dy*dy<20*20)
					{
						layer2b.remove(spr);
						//layer3.add(spr);
						//spr.play("inactive");
						//spr.y=2+7*(8-i);
						//spr.x=2;
						//spr.width=2;
						//spr.height=2;
						//spr.scrollFactor = new FlxPoint(0,0);
						collected[i]=true;
						FlxG.play(GameState.SndGet);
						flourish.at(spr);
						flourish.start(true,2,0);
						if (hudtexttimer>6)
						{
							hudtexttimer=4;
							this.hudtext.visible=true;
						}
					}
				}
			}
			for (i=0;i<this.respawnPoints.members.length;i++)
			{
				var t:FlxSprite = this.respawnPoints.members[i];
				var dx:Number = player.x-t.x;
				var dy:Number = player.y-t.y;
				if ((dx*dx+dy*dy<20*20) && (t._curAnim.name!="active"))
				{
					t.play("active",true);
					trace("changing");
					for (j=0;j<this.respawnPoints.members.length;j++)
					{
						if (j==i)
							continue;
						this.respawnPoints.members[j].play("inactive",true);
					}
					break;
				}
			}
			
			_time+=FlxG.elapsed;
			
			if (_time>2)
			{
				_time=0;
			//	this.tilemap.visible=!this.tilemap.visible;
			//	this.tilemap2.visible=!this.tilemap2.visible;
			}
			var moralxp:Number=0;
			var moralxm:Number=0;
			var moralyp:Number=0;
			var moralym:Number=0;
			
			for (var i:int=0;i<player.group.members.length;i++)
			{
				var oldPos:FlxPoint = new FlxPoint(player.group.members[i].x,player.group.members[i].y);
				FlxU.collide(player.group.members[i],tilemap);
				oldPos.x-=player.group.members[i].x;
				oldPos.y-=player.group.members[i].y;
				for (var j:int=0;j<player.group.members.length;j++)
				{
					if (i==j)
					{
						continue;
					}
					player.group.members[j].x-=oldPos.x;
					player.group.members[j].y-=oldPos.y;
				}
				player.x-=oldPos.x;
				player.y-=oldPos.y;
				if (oldPos.x>0)
				{
					moralxp+=oldPos.x;
				}
				else
				{
					moralxm+=oldPos.x;
				}				
				
				if (oldPos.y>0)
				{
					moralyp+=oldPos.y;
				}
				else
				{
					moralym+=oldPos.y;
				}
				
			}			
			
			moralxp*=FlxG.elapsed;
			moralxm*=FlxG.elapsed;
			moralyp*=FlxG.elapsed;
			moralym*=FlxG.elapsed;
			
			if ( (moralxp>0.1 && moralxm<-0.1) || (moralyp>0.1 && moralym<-0.1) || (moralxp>0.2) || (moralxm<-0.2) || (moralyp>0.2) || (moralym<-0.2))
			{
				for (i=0;i<this.respawnPoints.members.length;i++)
				{
					spr = respawnPoints.members[i];
					if (spr._curAnim.name=="active")
					{
						player.x=spr.x;
						player.y=spr.y;
						player.frame=0;
						player.spawn();
					}
				}
			}
			
			super.update();
			
			if (player.y<0)
			{
				FlxG.followTarget=null;
				gameover=true;
				FlxG.fade.start(0xffffffff,3,gameOver,true);
				player.group.kill();
				player.kill();
			}
			/*
			if (tilemap.collide(player.group))
			{
				player.restorePositions();
			}
			
			player.backupPositions();
			*/
		}
		public function gameOver():void
		{
			FlxG.state = new GameOverState();
		}
		override public function destroy():void
		{
			
			
			if (GameState.sndWhale1.playing && GameState.sndWhale1._fadeOutTimer<=0)
			{						
				GameState.sndWhale1.fadeOut(0.8);
			}
			if (GameState.sndWhale2.playing && GameState.sndWhale2._fadeOutTimer<=0)
			{						
				GameState.sndWhale2.fadeOut(0.8);
			}
			if (GameState.sndWhale3.playing && GameState.sndWhale3._fadeOutTimer<=0)
			{						
				GameState.sndWhale3.fadeOut(0.8);
			}
			if (GameState.sndWhale4.playing && GameState.sndWhale4._fadeOutTimer<=0)
			{						
				GameState.sndWhale4.fadeOut(0.8);
			}
			if (GameState.sndWhale5.playing && GameState.sndWhale5._fadeOutTimer<=0)
			{						
				GameState.sndWhale5.fadeOut(0.8);
			}
			if (GameState.sndWhale6.playing && GameState.sndWhale6._fadeOutTimer<=0)
			{						
				GameState.sndWhale6.fadeOut(0.8);
			}
			if (GameState.sndWhale7.playing && GameState.sndWhale7._fadeOutTimer<=0)
			{						
				GameState.sndWhale7.fadeOut(0.8);
			}
			if (GameState.sndWhale8.playing && GameState.sndWhale8._fadeOutTimer<=0)
			{						
				GameState.sndWhale8.fadeOut(0.8);
			}
			if (GameState.sndWhale9.playing && GameState.sndWhale9._fadeOutTimer<=0)
			{						
				GameState.sndWhale9.fadeOut(0.8);
			}
		}
	}
}